<?php

require_once 'base/GepLogalterasoliEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 */
class GepLogalterasoliEntity extends GepLogalterasoliEntityBase
{


    const IDATIVO = 'S';
    const IDINATIVO = 'N';
    const SEM_REGISTRO = 'SEM_REGISTRO';


    /**
     * Gera novo c?digo para o controle de encaminhamento.
     *
     * @param integer $nrorg N?mero da organiza??o.
     *
     * @return Ambigous <number, number>
     */
    public static function novoCodigoGepLogalterasoli($nrorg){
        $codigo = GepLogalterasoli::novoCodigo($nrorg);
        return ++$codigo;
    }


    /**      ok
     * Insere o log da solicitacao.
     *
     * @param integer $codigo      Novo codigo.
     * @param integer $solicitacao Numero da Solicitacao.
     * @param string  $texto_log   Texto com o log.
     * @param integer $operador    Codigo do operador.
     * @param string  $data        Data atual.
     * @param integer $nrorg       Numero da Organizacao.
     *
     * @return boolean
     */
    public function insereLogSolicitacao($codigo, $solicitacao, $texto_log, $operador, $data, $nrorg){
        try {
            $obj = new self();

            $obj->setNrlogalterasoli($codigo);
            $obj->setNrsolicitacao($solicitacao);
            $obj->setTxlogalterasoli($texto_log);
            $obj->setCdoperultatu($operador);
            $obj->setDtinclusao($data);
            $obj->setDtultatu($data);
            $obj->setIdativo(self::IDATIVO);
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->setNrorgultatu($nrorg);

            $obj->persist();

            return true;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Dados de um log de uma determinada solicita??o.
     *
     * @param integer $nrorg       N?mero da Organiza??o.
     * @param integer $solicitacao N?mero da Solicita??o.
     *
     * @throws Exception Caso n?o aja log.
     * @return GepLogalterasoliEntity
     */
    public static function dadosLogSolicitacao($nrorg, $solicitacao){
        $dados = GepLogalterasoli::consultaLogSolicitacao($nrorg, $solicitacao);

        if ($dados instanceof GepLogalterasoliEntity) {
            return $dados;
        }

        throw new Exception('GepLogalterasoliEntity: Nao ha log sobre esta solicitacao.');
    }


}